<template>
  <div>
    <h1>Estudiante</h1>
    <input v-model="nombre" type="text" placeholder="Nombre" />
    <br />
    <input v-model="apellido" type="text" placeholder="Apellido" />
    <br />
    <input v-model="cedula" type="text" placeholder="Cedula" />
    <br />
    <input v-model="telefono" type="text" placeholder="Teléfono" />
    <br />
    <button v-on:click="registrar" v-if="!mostrarBtn_actualizar">
      Registrar
    </button>
    <button v-if="mostrarBtn_actualizar" v-on:click="limpiarCampos">
      Cancelar
    </button>
    &nbsp;
    <button v-if="mostrarBtn_actualizar" v-on:click="cambiarDatos">
      Actualizar Datos
    </button>
    <br />
    <br />
    <input type="text" v-model="busqueda" />
    <button type="button" class="btn btn-primary" v-on:click="buscar">Buscar</button>
    <!--<button v-on:click="buscar">Buscar</button> -->

    <br />
    <br />
    <table>
      <tr>
        <th>Nombre</th>
        <th>Apellido</th>
        <th>Cédula</th>
        <th>Teléfono</th>
        <th>Acciones</th>
      </tr>
      <tr v-for="obj in filtroEstudiantes" :key="obj.cedula">
        <td>{{ obj.nombre }}</td>
        <td>{{ obj.apellido }}</td>
        <td>{{ obj.cedula }}</td>
        <td>{{ obj.telefono }}</td>
        <td>
          <button
            v-on:click="
              actualizar(obj.nombre, obj.apellido, obj.cedula, obj.telefono)
            "
          >
            Actualizar
          </button>
          <button v-on:click="eliminar(obj.cedula)">Eliminar</button>
        </td>
      </tr>
    </table>
    <!---
    <button v-on:click="cambiarEstado">Mostrar</button>
    <h2 v-if="mostrar">Titulo de mi app</h2>
  --></div>
</template>

<script>
const obj1 = {
  nombre: "Andres",
  apellido: "Quintero",
  cedula: "12345",
  telefono: "09876",
};
const obj2 = {
  nombre: "Juliana",
  apellido: "Perez",
  cedula: "98765",
  telefono: "335533",
};
const obj3 = {
  nombre: "Martha",
  apellido: "Perea",
  cedula: "54321",
  telefono: "019283",
};
export default {
  data: () => {
    return {
      nombre: null,
      apellido: null,
      cedula: null,
      telefono: null,
      estudiantes: [obj1, obj2, obj3],
      busqueda: null,
      mostrarBtn_actualizar: false,
      filtroEstudiantes: [obj1, obj2, obj3],
    };
  },
  methods: {
    registrar() {
      //Crear objeto json
      let objEstudiante = {
        nombre: this.nombre,
        apellido: this.apellido,
        cedula: this.cedula,
        telefono: this.telefono,
      };
      //Añadir el objeto al arreglo
      this.estudiantes.push(objEstudiante);
      console.log(this.estudiantes);
      this.limpiarCampos();
    },
    buscar() {
      //Valida, si el campo está vacío entonces muestra todos los estudiantes
      if (this.busqueda == null || this.busqueda == "") {
        this.filtroEstudiantes = this.estudiantes;
      } else {//sino entonces muestra la búsqueda
        let result = this.estudiantes.filter(
          (obj) => obj.cedula == this.busqueda
        );
        console.log(result);
        this.filtroEstudiantes = result;
      }
    },
    actualizar(nombre, apellido, cedula, telefono) {
      console.table({ nombre, apellido, cedula, telefono });
      this.nombre = nombre;
      this.apellido = apellido;
      this.cedula = cedula;
      this.telefono = telefono;
      this.mostrarBtn_actualizar = true;
    },
    limpiarCampos() {
      this.nombre = null;
      this.apellido = null;
      this.cedula = null;
      this.telefono = null;
      this.mostrarBtn_actualizar = false;
    },
    cambiarDatos() {
      //Recorrer el arreglo estudiantes
      /*
      this.estudiantes.forEach(objEstudiante => {
        if(objEstudiante.cedula == this.cedula){
          objEstudiante.nombre = this.nombre;
          objEstudiante.apellido = this.apellido;
          objEstudiante.telefono = this.telefono;
        }
      });
      this.limpiarCampos();
      */
      this.estudiantes.map((objEstudiante) => {
        if (objEstudiante.cedula == this.cedula) {
          objEstudiante.nombre = this.nombre;
          objEstudiante.apellido = this.apellido;
          objEstudiante.telefono = this.telefono;
          this.limpiarCampos();
        }
      });
    },
    eliminar(cedula) {
      let tempoEstudiantes = [];
      this.estudiantes.forEach((objEstudiante) => {
        if (objEstudiante.cedula != cedula) {
          tempoEstudiantes.push(objEstudiante);
        }
      });
      this.estudiantes = tempoEstudiantes;
    },
    /*
    cambiarEstado(){
        this.mostrar = !this.mostrar;
        console.table({mostrar: this.mostrar});
    }
    */
  },
};
</script>

<style>
table {
  width: 100%;
}
table,
tr,
td,
th {
  border: 1px solid black;
}
</style>